package io.gitlab.jfronny.inceptum.gtk.menu;

import org.gtk.gio.SimpleAction;
import org.gtk.glib.Variant;

import java.util.List;

public class RadioItem<T> extends MenuItem {
    private final List<T> options;

    public RadioItem(SimpleAction action, List<T> options) {
        super(action);
        this.options = options;
    }

    public void setSelected(T selected) {
        action.setState(Variant.newInt32(options.indexOf(selected)));
    }

    public T getSelected() {
        return options.get(action.getState().getInt32());
    }
}
